Subject: bug#41001: closed (Re: bug#41001: mkdir: cannot create directory‘test’: File exists)

From: [email-masked] (GNU bug Tracking System)
Date: Fri, 01 May 2020 15:56:02 +0000

Your bug report

#41001: mkdir: cannot create directory ‘test’: File exists

which was filed against the coreutils package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
41001: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=41001
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#41001: mkdir: cannot create directory ‘test’: File exists
From: Eric Blake <[email-masked]>
To: Jonny Grant <[email-masked]>, [email-masked]
Date: Fri, 1 May 2020 10:54:37 -0500
List-Id: <debbugs-submit.debbugs.gnu.org>

tag 41001 notabug
thanks

On 5/1/20 10:06 AM, Jonny Grant wrote:
> Hello!
> 
> Can this error message be clarified? The directory already exists, it is 
> not a file.

By one definition, a directory _is_ a file, just with different 
semantics (in the same way a block device, character device, symlink, 
fifo, or socket can also be a file).  It is not a regular file, but "a 
file" is any entry stored in a directory, and as subdirectories are 
stored in a directory, they count as files.

> 
> lib/mkdir-p.c:200 contains this line of code that triggers below:-
> 
> error (0, mkdir_errno, _("cannot create directory %s"), quote (dir));

The error message in question is coming from libc's strerror() function; 
if you want a different error message for EEXIST, you'll have to 
convince glibc to update their error string tables.  It is not something 
that coreutils directly controls.  And while we could indeed output a 
custom message instead of using strerror(), that would confuse people 
who have grown used to the strerror() message.

> 
> As it's easy enough to know that the reason mkdir fails is because 
> 'test' a directory that already exists.
> 
> Easy enough to check with stat() and S_ISDIR(sb.st_mode)
> 
> Can this be changed? Maybe I can make a patch for it.
> Jonny
> 
> 
> 
> $ mkdir test
> $ mkdir test
> mkdir: cannot create directory ‘test’: File exists

If nothing else, you may want to consider using 'mkdir -p test', which 
specifically checks if the reason for an EEXIST failure is because the 
directory already exists.  Once you do that, you don't need to patch 
coreutils.

Thus, I'm closing this as not a bug; but feel free to respond further 
with any more comments on the topic.

-- 
Eric Blake, Principal Software Engineer
Red Hat, Inc.           +1-919-301-3226
Virtualization:  qemu.org | libvirt.org

Subject: mkdir: cannot create directory ‘test’: File exists
From: Jonny Grant <[email-masked]>
To: [email-masked]
Date: Fri, 1 May 2020 16:06:36 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

Hello!

Can this error message be clarified? The directory already exists, it is 
not a file.

lib/mkdir-p.c:200 contains this line of code that triggers below:-

error (0, mkdir_errno, _("cannot create directory %s"), quote (dir));

As it's easy enough to know that the reason mkdir fails is because 
'test' a directory that already exists.

Easy enough to check with stat() and S_ISDIR(sb.st_mode)

Can this be changed? Maybe I can make a patch for it.
Jonny

$ mkdir test
$ mkdir test
mkdir: cannot create directory ‘test’: File exists
$ mkdir --version
mkdir (GNU coreutils) 8.28
Copyright (C) 2017 Free Software Foundation, Inc.
License GPLv3+: GNU GPL version 3 or later 
<http://gnu.org/licenses/gpl.html>.
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law.

Written by David MacKenzie.
$